require 'sire/entity_builder'

module Sire
  class Relation < Module
    class << self
      alias_method :define, :new
    end

    def initialize(*entity_types)
      @entity_types = entity_types
      extend ClassMethods
    end

    module ClassMethods
      attr_reader :entity_types

      def self.extended(child)
        EntityBuilder.nestables << child
      end

      # TODO: Should iterate over entity_types and find the best key match
      def new(value)
        acceptable?(value) ? value : default.new(value)
      end

      private

      def acceptable?(value)
        entity_types.include?(value.class)
      end

      def default
        entity_types[0]
      end
    end
  end
end
